require("XGUI_Lib")

local AddFilm
local AddMovie
local AddStars
local AddEpNums
local RepeatPrems
local AddPDateDesc
local AddPDateTitle

local function Pass1Func(proc,program)
	local cat,str,i
	XGUI.SetStatus(2,"Processing "..XGUI_Lib.XS.Val(program.Title))
	if program.Category then
		cat=XGUI_Lib.XS.Val(program.Category)
		end
	if ((cat=="Film")or(cat=="Movie")) then
		if AddFilm then
			program.Title=XGUI_Lib.XS.Prefix(program.Title,"Film:") end
		if AddMovie then
			program.Title=XGUI_Lib.XS.Prefix(program.Title,"Movie:") end
		end
	if AddStars and (program.StarRating)and(program.StarRating.Number~=0) then
		str=" "
		for i = 1,program.StarRating.Number do
			str=str.."*"
			end
		program.Title=XGUI_Lib.XS.Cat(program.Title,str)
		end
	if AddEpNums and program.Episode then
		str=nil
		if program.Episode.System=="xmltv_ns" then
			local nums={}
			for n1,n2 in string.gfind(program.Episode.Number,".*%.%s*(%d*)%s*%/%s*(%d*)%s*%..*") do
				table.insert(nums,tonumber(n1))
				table.insert(nums,tonumber(n2))
				end
			if table.getn(nums)==2 then
				if (not nums[1])and(not nums[2]) then 
					str=nil
					elseif not nums[2] then
						str=string.format("Episode %d",nums[1]+1)
						elseif not nums[1] then str=nil--print (string.format("%d episodes",nums[2]))
						else str=string.format("Episode %d of %d",nums[1]+1,nums[2])
						end
				end
			end
		if str then
			if program.Sub_Title then
				str=str.." - "
				end
			program.Sub_Title=XGUI_Lib.XS.Prefix(program.Sub_Title,str)
			end
		end
	if RepeatPrems then
		if (not program.PreviouslyShown)and(not program.Premiere) then
			program.Premiere="Not a repeat"
			end
		end
	if AddPDateDesc then
		if program.Date then
			program.Description=XGUI_Lib.XS.Cat(program.Description,"Date: "..program.Date)
			end
		end
	if AddPDateTitle then
		if program.Date then
			program.Title=XGUI_Lib.XS.Cat(program.Title," ("..program.Date..")")
			end
		end
	return program
	end

local function Pass1Start(proc)
	AddFilm=toboolean(XGUI.GetSetting(proc,"AddFilm",true))
	AddMovie=toboolean(XGUI.GetSetting(proc,"AddMovie",false))
	AddStars=toboolean(XGUI.GetSetting(proc,"AddStars",true))
	AddEpNums=toboolean(XGUI.GetSetting(proc,"AddEpNums",true))
	RepeatPrems=toboolean(XGUI.GetSetting(proc,"RepeatPrems",false))
	AddPDateDesc=toboolean(XGUI.GetSetting(proc,"AddPDateDesc",false))
	AddPDateTitle=toboolean(XGUI.GetSetting(proc,"AddPDateTitle",false))
	return XGUI.OK
	end

local function Init(proc)
	XGUI.AddSetting(proc,"AddFilm",XGUI.SettingType.Boolean,"true","Add \"Film:\" to the title of films")
	XGUI.AddSetting(proc,"AddMovie",XGUI.SettingType.Boolean,"false","Add \"Movie:\" to the title of films")
	XGUI.AddSetting(proc,"AddStars",XGUI.SettingType.Boolean,"true","Add stars to program titles")
	XGUI.AddSetting(proc,"AddEpNums",XGUI.SettingType.Boolean,"true","Add episode numbers to program subtitle")
	XGUI.AddSetting(proc,"RepeatPrems",XGUI.SettingType.Boolean,"false","Mark all non-repeats as \"Premieres\"")
	XGUI.AddSetting(proc,"AddPDateDesc",XGUI.SettingType.Boolean,"false","Add production date to description")
	XGUI.AddSetting(proc,"AddPDateTitle",XGUI.SettingType.Boolean,"false","Add production date to title")
	return XGUI.OK
	end

PostProcs.PrgDets={
	Name = "Program Details Processor",
	Version = "1.0",
	Author = "Alan Birtles",
	InfoURL = "http://www.birtles.org.uk/xmltv",
	Passes={
		Pass1={
			Start=Pass1Start,
			Type=XGUI.PassTypes.Program,
			Func=Pass1Func,
			},
		},
	Init=Init,		
	}
